void ClearAllChans();
int isjoined(ChannelListType cptr, UserListType uptr);
int DelLamer(ChannelListType cptr, char* Mask);
void AddLamer(ChannelListType cptr, time_t BanTime, time_t LastSeen, char* Address, char *Reason);
LamerListType GetLamer(ChannelListType cptr, char *mask);
void RemoveNickFromChannel(ChannelListType cptr, UserListType uptr);
void RemoveNickFromAllChannels(UserListType uptr);
int PublicReplyAllowed(HandleListType hptr);
int ChanUserLevel(HandleListType hptr);
char *GetInfo(HandleListType hptr);
char *GetMaskName(ChannelListType cptr, UserListType uptr);
BanListType search_ban(ChannelListType cptr, char *banstring);
char *GetModeString(char *ModeString, int PlusModes, int MinModes, char *key, char *limit);
void SetTopics(int period);
ChannelListType GetChannel(char *Channel);
int IsProt(ChannelListType ChanPtr, char *hostmask);

boolean IsChanOwner(HandleListType hptr);
boolean IsChanCoOwner(HandleListType hptr);
boolean IsChanManager(HandleListType hptr);
boolean IsChanOp(HandleListType hptr);
boolean IsChanPeon(HandleListType hptr);

LamerListType IsChanLamer(ChannelListType cptr, UserListType uptr);
int IsChanAOp(HandleListType hptr);
void SetChanAOp(HandleListType hptr, int setting);
void SetInfo(ChannelListType cptr, HandleListType hptr, char *Info);
void SetLastSeen(ChannelListType cptr, HandleListType hptr, int action);
time_t GetSeenTime(ChannelListType cptr, char *Handle);
int IsInChan(HandleListType hptr);
void SendInfoLine(ChannelListType cptr, HandleListType hptr, UserListType uptr);
HandleListType FindBestUserMatchPass(ChannelListType cptr, UserListType uptr);
HandleListType FindBestUserMatch(ChannelListType cptr, UserListType uptr);
boolean IsDeop(char *Modes);
boolean IsBan(char *Modes);
void ProcessKick(ChannelListType cptr, UserListType uptr, char *Kicked);
void on_mode(ChannelListType cptr, UserListType uptr, char *rest);
void ConvertModeString(char *ModeString, int *PlusModes, int *MinModes,char **Key, char **limit);
void ProcessJoin(ChannelListType ChanNode, UserListType UserNode, char* channel, char type);
void ProcessPart(ChannelListType ChanPtr, UserListType UserNode);
void KillChanList();
int DelChan(char *Channel);
int AddChan(char* ChanName, int IsRegged, char* ModeString, char* ChanTopic, char* ChanEmail,
            char* Description, char* URL, char* ReggedBy,
            int settings[NUMOFCHANSETTINGS],
            time_t CreationDate, time_t LastAccess);
/*
OperListType FindOp(OperSegment TheSegment, char *OperAddy);
int AddOp(OperSegment NewOperSeg, char *OperAddy,
          char *Handle, char *Pass, char *Info,
          int AutoOp, int PwdReq, time_t LastSeen);
*/
void WriteChanOpFile(ChannelListType ChanPtr);
/*
int FDelUserByHost(OperSegment OpSeg, char *OperAddy, ChannelListType cptr, UserListType uptr);
int FDelUser(OperSegment OpSeg, char *OperAddy, ChannelListType cptr, UserListType uptr);
int DelUser(OperSegment OpSeg, char *OperAddy, ChannelListType cptr, UserListType uptr);
int DelUserSeg(OperSegment OpSeg, char *OperAddy);
*/
void add_ban(ChannelListType cptr, char *banstring);
int delete_ban(ChannelListType cptr, char *banstring);
int DeleteExpiredBans(ChannelListType cptr, BanListType * b_list, time_t period);
void SaveDel(ChannelListType cptr);
void ExpireChannels(UserListType uptr);
void CheckBanTimeouts();
int channel_massunban(ChannelListType Channel);
int channel_unban(ChannelListType Channel, char* banstring);
MaskListType AddMask(HandleListType hptr, char *Mask);
HandleListType AddHandle(ChannelListType cptr, char *Handle, char *Pass, char *Info, char Level, int AutoOp, time_t LastSeen, int InChan);
HandleListType SetHandle(HandleListType Handle, char *NewHandle);
HandleListType FindHandle(ChannelListType cptr, char* Handle);
MaskListType FindMask(HandleListType hptr, char* Mask);
int DelMask(HandleListType hptr, char* Mask);
void DelHandle(ChannelListType cptr, HandleListType hptr);
int GetChanStats(ChannelListType cptr, int *w, int *c, int *m, int *o, int *p, int *b);

